# Overview

Drupal is a free and open-source content-management framework written in PHP and distributed under the GNU General Public License. It is used as a back-end framework for at least 2.1% of all Web sites worldwide ranging from personal blogs to corporate, political, and government sites.

# Usage

## General Usage

To deploy a Drupal service on IIS:

    juju deploy cs:~cloudbaseit/win2012r2/drupal-iis

As a database backend, one of the following relational databases can be used: [MySQL](https://www.mysql.com), [PostgreSQL](http://www.postgresql.org) or [MSSQL](https://www.microsoft.com/en-us/server-cloud/products/sql-server/).

To add a relation with the MySQL database charm:

    juju deploy mysql
    juju add-relation drupal-iis mysql

To add a relation with the PostgreSQL database charm:

    juju deploy postgresql
    juju add-relation drupal-iis postgresql:db

To add a relation with the SQL Server Express database charm:

    juju deploy cs:~cloudbaseit/win2012r2/mssql-express
    juju add-relation drupal-iis mssql-express

## Scale out usage

To add another unit to your deployment:

    juju add-unit drupal-iis

To deploy a memcached server and add memcache caching to the Drupal deployment.

    juju deploy memcached
    juju add-relation drupal-iis memcached

To add a reverse proxy relation with haproxy and distribute connections from one frontend port to your charm units.

    juju deploy haproxy
    juju add-relation drupal-iis haproxy

# Configuration

* `site-name` - Name of the Drupal website.

* `site-mail` - E-mail used by Drupal to send notifications.

* `admin-user-name` - User name used by admin account.

* `admin-password` - Password used by the admin account.

* `admin-mail` - E-mail of the administrative account 'admin'.

* `php-max-execution-time` - The maximum execution time in seconds a PHP script is allowed to take.

* `php-max-requests` - Maximum number of request for the IIS PHP handler.

To dynamically change a config option:

    juju set drupal-iis <config_option>=<config_value>
